=== debian/changelog ===
kaiming (1.0.0-ok1k0.7) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.处理打印信息
                  2.解决批量安装时只umount一次问题
                  3.xdg功能 dbus v11/no v11路径适配
                  4.处理服务类应用字段
                  5.id命名规则放宽松
  * 其他改动影响域: 安装、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 07 May 2025 10:23:16 +0800

kaiming (1.0.0-ok1k0.6) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.修复快捷方式启动开明应用的问题
                  2.app间调用
                  3.v10sp1适配
                  4.处理服务类应用文件路径
                  5.处理网页应用图标
                  6.修复gsettings获取值错误问题
  * 其他改动影响域: 构建、安装、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Sun, 04 May 2025 19:23:02 +0800

kaiming (1.0.0-ok1k0.5) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.兼容depends列表中包含空串的场景
                  2.crun分离及删除应用结束后的目录
                  3.增加xdgopen、网络、蓝牙权限到构建环境
                  4.增加polkit配置，以方便构建时安装依赖
                  5.kaiming build-init时安装依赖的方式替换
                  6.kaiming run分离引起构建问题修改
  * 其他改动影响域: 构建、运行 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 28 Apr 2025 17:02:40 +0800

kaiming (1.0.0-ok1k0.4) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:
    修改计算包大小的方式;更换md5sum的方案;修复/opt/kaiming为空时，update报段错误的问题;处理默认版本解析错误
  * 其他改动影响域: kaiming build-export 

 -- zhaominyong <zhaominyong@kylinos.cn>  Tue, 22 Apr 2025 16:11:31 +0800

kaiming (1.0.0-ok1k0.3) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 优化kaiming run启动时间；修复kaiming which问题
  * 其他改动影响域: kaiming which; kaiming run; 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 16 Apr 2025 16:35:16 +0800

kaiming (1.0.0-ok1k0.2) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 修改下载源时curl设置的链接超时
  * 其他改动影响域: 无 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 17:28:13 +0800

kaiming (1.0.0-ok1k0.1) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: CI构建，版本增加规则
  * 其他改动影响域: 无 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 22:20:26 +0800

kaiming (1.0.0-ok1k0.0) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 准备发布，初始化版本号
  * 其他改动影响域: 无

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 21:33:24 +0800

kaiming (0.90.1-ok0.2k0.31) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:
    添加KSAF和执行控制标记；卸载runtime/base时，打印将要被卸载的软件包;build-init安装base\runtime成功后数组越界问题
  * 其他改动影响域: kaiming install、uninstall

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Thu, 10 Apr 2025 16:13:57 +0800

kaiming (0.90.1-ok0.2k0.30) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: kaiming init自动安装依赖越界问题修改
  * 其他改动影响域: kaiming包构建 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 09 Apr 2025 18:04:58 +0800

kaiming (0.90.1-ok0.2k0.29) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 无法在线安装devel包；安装base包卡住问题
  * 其他改动影响域: kaiming install 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 09 Apr 2025 16:18:12 +0800

kaiming (0.90.1-ok0.2k0.28) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: kwre部署后删除files目录；优化kaiming info模块；递归卸载依赖软件时，补充kwre应用卸载逻辑
  * 其他改动影响域: kaiming install;kaiming info等

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Wed, 07 Apr 2025 10:28:01 +0800

kaiming (0.90.1-ok0.2k0.27) v11-2503; urgency=medium

  * BUG: 修改kwre部署文件删除逻辑，修复base文件无法删除问题
  * 任务: 新增which模块，用于搜索指定文件属于哪个软件包
  * 需求: [448097] 新增功能 kaiming which ，查询文件所属哪个包
  * 其他改动说明:
  * 其他改动影响域:

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Wed, 02 Apr 2025 09:56:44 +0800

kaiming (0.90.1-ok0.2k0.26) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 自包含sw_64适配改造
  * 其他改动影响域: sw_64架构

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 30 Mar 2025 10:10:30 +0800
 

kaiming (0.90.1-ok0.2k0.25) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 简化yaml编写
  * 其他改动影响域: 构建、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 27 Mar 2025 01:53:17 +0800

kaiming (0.90.1-ok0.2k0.24) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 自包含loong64适配改造
  * 其他改动影响域: loong64架构

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 24 Mar 2025 17:48:13 +0800

kaiming (0.90.1-ok0.2k0.23) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: loong64适配改造
  * 其他改动影响域: loong64架构

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 20 Mar 2025 20:21:45 +0800

kaiming (0.90.1-ok0.2k0.22) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:  完善开明分离功能
  * 其他改动影响域: 暂无

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 17 Mar 2025 17:24:59 +0800

kaiming (0.90.1-ok0.2k0.21) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 开明自包含功能
  * 其他改动影响域: 暂无

 -- luchaoyang <luchaoyang@kylinos.cn>  Fri, 14 Mar 2025 13:34:50 +0800

kaiming (0.90.1-ok0.2k0.20) v11-2503; urgency=medium

  * BUG: 332587 安全编译选项检查结果中，kaiming存在安全编译风险项
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 暂无
  * 其他改动影响域: 暂无

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 06 Mar 2025 19:15:31 +0800

kaiming (0.90.1-ok0.2k0.19) v11-2503; urgency=medium

  * BUG:  #330342 【开明】  执行kaiming run 命令提示错误
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 使用过程中发现的一些问题修复或优化
  * 其他改动影响域: 开明包使用

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 24 Feb 2025 15:53:27 +0800

kaiming (0.90.1-ok0.2k0.18) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 使用过程中发现的一些问题修复或优化
  * 其他改动影响域: 开明包使用

 -- yushuoqi <yushuoqi@kylinos.cn>  Wed, 12 Feb 2025 16:48:27 +0800

kaiming (0.90.1-ok0.2k0.17) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 版本号3段是在线安装不上
  * 其他改动影响域: 开明包在线安装

 -- zhaominyong <zhaominyong@kylinos.cn>  Fri, 24 Jan 2025 16:07:02 +0800

kaiming (0.90.1-ok0.2k0.16) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 新的base、runtime中bin等目录换成了软连接，需要注释部分代码
  * 其他改动影响域: 构建

 -- zhaominyong <zhaominyong@kylinos.cn>  Fri, 17 Jan 2025 17:11:36 +0800

kaiming (0.90.1-ok0.2k0.15) v11-2503; urgency=medium

  * BUG: 无

