=== debian/control ===
Source: kaiming
Section: admin
Priority: optional
Maintainer: Kaiming Maintenance Team <yushuoqi@kylinos.cn>
Uploaders:
    luchaoyang <luchaoyang@kylinos.cn>,
    yushuoqi <yushuoqi@kylinos.cn>,
    liucong <liucong1@kylinos.cn>,
    zhaominyong <zhaominyong@kylinos.cn>,
Build-Depends:
        debhelper (>= 9),
        build-essential,
        libglib2.0-dev,
        libostree-dev (>= 2020.8),
        libxml2-dev (>= 2.4),
        pkg-config,
        cmake,
        ninja-build,
        libdbus-glib-1-dev,
        nlohmann-json3-dev,
        libdbus-1-dev,
        libcurl4-gnutls-dev,
        zlib1g-dev,
        libelf-dev,
        liblz4-dev,
        liblzma-dev,
        libdeflate-dev,
        libzstd-dev,
        uuid-dev,
        libgtest-dev,
        crun,
        libyajl-dev,
        patchelf
Standards-Version: 4.6.2
Homepage: https://gitee.com/openkylin/community/tree/master/sig/KaiMing
Vcs-Git: https://gitee.com/openkylin/kaiming.git
Vcs-Browser: https://gitee.com/openkylin/kaiming
Rules-Requires-Root: no

Package: kaiming
Architecture: linux-any
Depends:
        adduser,
        rsync,
        ${misc:Depends},
Description: Application deployment framework for desktop apps
