=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.

export DH_VERBOSE = 1
export DEB_BUILD_OPTIONS = nocheck # Avoid dh_auto_test check


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- "-GNinja"

override_dh_auto_build:
	dh_auto_build -- -j8

# 重写 dh_auto_install
override_dh_auto_install:
	dh_auto_install
	# 调用脚本收集二进制依赖库
	mkdir -p debian/kaiming/opt/kaiming-tools/lib/
	# 进行依赖复制和rpath设置
	./shells/bundle_dependencies.sh

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -- -l/opt/kaiming-tools/lib

override_dh_installdocs:

override_dh_installchangelogs:
